 /* Copyright IBM Corp. 2013, 2016.  All Rights Reserved.
  *
  * US Government Users Restricted Rights - Use, duplication or disclosure
  * restricted by GSA ADP Schedule Contract with IBM Corp.
  */
(function() {
dojo.provide("com.ibm.rdm.web.compare.CompareConstants");

com.ibm.rdm.web.compare.CompareConstants = {
	
	// Types of changes.  These correspond to the types of changes that VVC notifies us of, but the
	// constants may be used in non-VVC contexts as well.
	DELTA_TYPE_ADD: "AddDelta",
	DELTA_TYPE_DELETE: "DeleteDelta",
	DELTA_TYPE_CHANGE: "ChangeDelta",
	DELTA_TYPE_OTHER_CONTRIBUTOR_CHANGE: "OtherContributorChangeDelta",
	// This one not received from VVC, but used internally to indicate a moved artifact.
	DELTA_TYPE_MOVE: "MoveDelta",
	
	// These not received from VVC, but used internally to indicate various types of changes to a resource.
	DELTA_TYPE_SOURCE_ADD: "ADDED_IN_SOURCE",
	DELTA_TYPE_SOURCE_DELETE: "DELETED_IN_SOURCE",
	DELTA_TYPE_SOURCE_CHANGE: "CHANGED_IN_SOURCE",
	DELTA_TYPE_SOURCE_MOVE: "MOVED_IN_SOURCE",
	DELTA_TYPE_TARGET_ADD: "ADDED_IN_TARGET",
	DELTA_TYPE_TARGET_DELETE: "DELETED_IN_TARGET",
	DELTA_TYPE_TARGET_CHANGE: "CHANGED_IN_TARGET",
	DELTA_TYPE_LINKS_CHANGE: "LINKS_CHANGED",
	DELTA_TYPE_BOOKMARKS_CHANGE: "BOOKMARKS_CHANGED",
	DELTA_TYPE_TERM_INFO_CHANGE: "TERM_INFO_CHANGED",
	DELTA_TYPE_COMMENTS_CHANGE: "COMMENTS_CHANGED",
	DELTA_TYPE_BINDINGS_CHANGE: "BINDINGS_CHANGED",
	DELTA_TYPE_STRUCTURE_CHANGE: "STRUCTURE_CHANGED",
	DELTA_TYPE_WRAPPED_RESOURCE_CHANGE: "WRAPPED_RESOURCE_CHANGED",
	
	// Groups of delta types
	DELTA_TYPES_DIRECT: [
		"ADDED_IN_SOURCE",
		"DELETED_IN_SOURCE",
		"CHANGED_IN_SOURCE",
		"ADDED_IN_TARGET",
		"DELETED_IN_TARGET",
		"CHANGED_IN_TARGET"
	],
	DELTA_TYPES_INDIRECT: [
		"LINKS_CHANGED",
		"BOOKMARKS_CHANGED",
		"COMMENTS_CHANGED",
		"BINDINGS_CHANGED",
		"STRUCTURE_CHANGED",
		"WRAPPED_RESOURCE_CHANGED"
	],
	
	// Indicators for the type of display that widgets should display for an artifact.
	DISPLAY_AS_ADDED: "DISPLAY_AS_ADDED",
	DISPLAY_AS_DELETED: "DISPLAY_AS_DELETED",
	DISPLAY_AS_CHANGED: "DISPLAY_AS_CHANGED",
	DISPLAY_AS_NOT_CHANGED: "DISPLAY_AS_NOT_CHANGED",
	DISPLAY_AS_LINKS_CHANGED: "DISPLAY_AS_LINKS_CHANGED",
	COMPUTE_DISPLAY_FROM_DELTAS: "COMPUTE_DISPLAY_FROM_DELTAS",  // means we should look at the resourceDeltas to decide
	
	DELTA_TYPE_VVC_FAKE_CONFLICT_INCORRECT_SOURCE: "DELTA_TYPE_VVC_FAKE_CONFLICT_INCORRECT_SOURCE",
	DELTA_TYPE_VVC_FAKE_CONFLICT_INCORRECT_TARGET: "DELTA_TYPE_VVC_FAKE_CONFLICT_INCORRECT_TARGET",
	
	// Types of structure diff changes as given by the /rm/diff/structure service.
	STRUCTURE_DIFF_TYPE_ADD: "http://www.ibm.com/xmlns/rrm/4.0/diff/structureDiffType#Add",
	STRUCTURE_DIFF_TYPE_REMOVE: "http://www.ibm.com/xmlns/rrm/4.0/diff/structureDiffType#Remove",
	STRUCTURE_DIFF_TYPE_MOVE: "http://www.ibm.com/xmlns/rrm/4.0/diff/structureDiffType#Move",
	
	// A special well-known URI to indicate the root node that notionally comes before all other nodes in
	// a structure difference.
	STRUCTURE_DIFF_ROOT_URI: "https://root",
	
	// Indicators for resource types.
	ResourceType: {
		ARTIFACT: "artifact",
		LINK: "link",
		TAG: "tag",
		VIEW: "view",
		GLOSSARY_TERM_INFO: "glossaryTermInfo",
		FOLDER: "folder",
		BOOKMARK: "bookmark",
		COMMENT: "comment",
		MODULE_STRUCTURE: "moduleStructure",
		MODULE_BINDING: "moduleBinding",
		TYPE: "type",
		OBJECT_TYPE: "objectType",
        ATTRIBUTE_DEFINITION: "attributeDefinition",
        ATTRIBUTE_TYPE: "attributeType",
        ENUM_ATTRIBUTE: "enumEntry",
        LINK_CONSTRAINTS: "linkConstraints",
        LINK_TYPE: "linkType",
        REQ_IF_DEFINITION: "reqIFDataDefinition",
        REQ_IF_PACKAGE: "reqIFPackage",
        WRAPPED_RESOURCE: "wrappedResource"
	}
};

})();
