/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014, 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.scm.web.ui.internal.process.operationbehavior.WorkItemsMatchQueryDeliverEditor");

dojo.require("com.ibm.team.process.web.ui.operationbehavior.AbstractOperationBehaviorCustomEditor");
dojo.require("com.ibm.team.rtc.foundation.web.ui.util.Sprites");
dojo.require("com.ibm.team.scm.web.client.util");
dojo.require("com.ibm.team.scm.web.ui.internal.process.ProcessImagePool");
dojo.require("com.ibm.team.scm.web.ui.internal.process.ProcessSpecificationConstants");
dojo.require("com.ibm.team.scm.web.ui.internal.process.operationbehavior.ComponentGrid");
dojo.require("com.ibm.team.scm.web.ui.internal.process.operationbehavior.MessageDisplayWidget");
dojo.require("com.ibm.team.scm.web.ui.internal.process.operationbehavior.WorkItemQuerySelectionDialog");
dojo.require("com.ibm.team.scm.web.ui.internal.process.operationbehavior.WorkItemsMatchQueryDeliverModel");
dojo.require("dijit._Templated");
dojo.require("dojo.i18n");
dojo.require("dojo.string");
dojo.require("jazz.ui.toolbar.Button");

dojo.requireLocalization("com.ibm.team.scm.web.ui.internal.process", "OperationBehaviorMessages");

(function() {
var OperationBehaviorMessages= dojo.i18n.getLocalization("com.ibm.team.scm.web.ui.internal.process", "OperationBehaviorMessages");

var team= com.ibm.team;
var AbstractOperationBehaviorCustomEditor= team.process.web.ui.operationbehavior.AbstractOperationBehaviorCustomEditor;
var Sprites= team.rtc.foundation.web.ui.util.Sprites;
var web= team.scm.web;
var util= web.client.util;
var process= web.ui.internal.process;
var ProcessImagePool= process.ProcessImagePool;
var ProcessSpecificationConstants= process.ProcessSpecificationConstants;
var operationbehavior= process.operationbehavior;
var ComponentGrid= operationbehavior.ComponentGrid;
var MessageDisplayWidget= operationbehavior.MessageDisplayWidget;
var WorkItemQuerySelectionDialog= operationbehavior.WorkItemQuerySelectionDialog;
var WorkItemsMatchQueryDeliverModel= operationbehavior.WorkItemsMatchQueryDeliverModel;
var WorkItemsMatchQueryDeliverModelParams= WorkItemsMatchQueryDeliverModel.WorkItemsMatchQueryDeliverModelParams;
var _Templated= dijit._Templated;
var Button= jazz.ui.toolbar.Button;

/**
 * Precondition Editor for com.ibm.team.scm.server.workItemsMatchQueryDeliverAdvisor.
 * 
 */
dojo.declare("com.ibm.team.scm.web.ui.internal.process.operationbehavior.WorkItemsMatchQueryDeliverEditor", [ AbstractOperationBehaviorCustomEditor, _Templated], {

	templatePath: dojo.moduleUrl(ProcessSpecificationConstants.MODULE_URL, ProcessSpecificationConstants.WIDGET_BASE + "WorkItemsMatchQueryDeliverEditor.html"),

	//_messages: null,

	//_processSpecConstants: null,

	//_componentsDropDown: null,

	//_changesetDropDown: null,

	//_otherProjectAreaDropDown: null,

	//_foreignQueryDropDown: null,

	//_componentsTable: null,

	//_addActionsNodeElement: null,

	//_editActionsNodeElement: null,

	//_queryDisplayNode: null,

	//_messagesDiv: null,

	//_mainContent: null,

	//_componentGrid: null,

	//_addComponentButton: null,

	//_editQueryButton: null,

	//_messageDisplayWidget: null,

	//_isDestroyed: null,

	//_workItemsMatchQueryDeliverModel: null,

	constructor: function(params) {
		this._messages= OperationBehaviorMessages;
		this._processSpecConstants= ProcessSpecificationConstants;
	},

	postCreate: function() {
		this.inherited("postCreate", arguments, []);
		this._isDestroyed= false;
		this._messageDisplayWidget= new MessageDisplayWidget();
		dojo.place(this._messageDisplayWidget.domNode, this._messagesDiv);
		if (!util.workItemsInstalled()) {
			var error= new Error();
			error.status= MessageDisplayWidget.TYPE_INFO;
			error.message= OperationBehaviorMessages.MessageDisplay_WorkItemMissing;
			this._messageDisplayWidget.showErrorMessage(error);
			return ;
		}
		this._messageDisplayWidget.showLoadingMessage();
		dojo.toggleClass(this._mainContent, ProcessSpecificationConstants.STYLE_HIDE, true);
		this._createActionButtons();
		this._createGridViewer();
		this._createEventHandlers();
		dojo.place(dojo.doc.createTextNode(OperationBehaviorMessages.WorkItemsMatchQueryDeliver_messageQueryNotSet), this._queryDisplayNode);
	},

	destroy: function(preserveDom) {
		this._isDestroyed= true;
		this._addComponentButton.destroy(preserveDom);
		this._editQueryButton.destroy(preserveDom);
		this._messageDisplayWidget.destroy(preserveDom);
		this._componentGrid.getGridViewerNode().destroy(preserveDom);
		this.inherited("destroy", arguments, [preserveDom]);
	},

	initialize: function(content, operationBehaviorId) {
		this.inherited("initialize", arguments, [content, operationBehaviorId]);
		var params= new WorkItemsMatchQueryDeliverModelParams();
		params.preconditionString= content;
		this._workItemsMatchQueryDeliverModel= new WorkItemsMatchQueryDeliverModel(params);
		var onSuccess= dojo.hitch(this, "_onPreconditionsFetchSuccess");
		var onFailure= dojo.hitch(this, "_onReceivingError");
		var result= this._workItemsMatchQueryDeliverModel.fetchPreConditionDisplayData();
		result.then(onSuccess, onFailure);
	},

	getContent: function() {
		if (this._workItemsMatchQueryDeliverModel != null) {
			return dojo.toJson(this._workItemsMatchQueryDeliverModel.getPreConditionData(), false);
		}
		return null;
	},

	canSave: function() {
		return true;
	},

	validate: function() {
		return null;
	},

	changesPending: function() {
		if (this._workItemsMatchQueryDeliverModel != null) 
			return this._workItemsMatchQueryDeliverModel.changesPending();
		return false;
	},

	modelChanged: function() {
		this.notifyContentChanged();
	},

	_createActionButtons: function() {
		var addConditionsButtonParams= {};
		addConditionsButtonParams.title= OperationBehaviorMessages.WorkItemsMatchQueryDeliver_actionAddComponentsTitle;
		addConditionsButtonParams.label= OperationBehaviorMessages.WorkItemsMatchQueryDeliver_actionAddComponentsLabel;
		addConditionsButtonParams.onClick= dojo.hitch(this, function(event) {
			dojo.stopEvent(event);
			this._handleAddTableEntry();
		});
		addConditionsButtonParams.imgClass= Sprites.cssClassName(ProcessImagePool.ADD);
		this._addComponentButton= new Button(addConditionsButtonParams);
		dojo.place(this._addComponentButton.domNode, this._addActionsNodeElement);
		var editConditionsButtonParams= {};
		editConditionsButtonParams.title= OperationBehaviorMessages.WorkItemsMatchQueryDeliver_actionSelectQuery;
		editConditionsButtonParams.label= OperationBehaviorMessages.WorkItemsMatchQueryDeliver_actionSelectQuery;
		editConditionsButtonParams.onClick= dojo.hitch(this, function(event) {
			dojo.stopEvent(event);
			this._handleAddQuery();
		});
		this._editQueryButton= new Button(editConditionsButtonParams);
		dojo.place(this._editQueryButton.domNode, this._editActionsNodeElement);
	},

	_createGridViewer: function() {
		this._componentGrid= new ComponentGrid();
		dojo.place(this._componentGrid.getGridViewerNode().domNode, this._componentsTable);
	},

	_createEventHandlers: function() {
		var changeEventHandler= dojo.hitch(this, function(event) {
			this._workItemsMatchQueryDeliverModel.markDirty();
			this._workItemsMatchQueryDeliverModel.setComponentID(this._componentsDropDown.value);
			this._handleComponentDropDownChange();
		});
		dojo.connect(this._componentsDropDown, 'change', changeEventHandler);
		var changesetOptionHandler= dojo.hitch(this, function(event) {
			this._workItemsMatchQueryDeliverModel.markDirty();
			this._workItemsMatchQueryDeliverModel.setCurrentWorkItemOptionID(this._changesetDropDown.value);
		});
		dojo.connect(this._changesetDropDown, 'change', changesetOptionHandler);
		var workitemOptionHandler= dojo.hitch(this, function(event) {
			this._workItemsMatchQueryDeliverModel.markDirty();
			this._workItemsMatchQueryDeliverModel.setCurrentProjectAreaOptionID(this._otherProjectAreaDropDown.value);
		});
		dojo.connect(this._otherProjectAreaDropDown, 'change', workitemOptionHandler);
		var foreignQueryOptionHandler= dojo.hitch(this, function(event) {
			this._workItemsMatchQueryDeliverModel.markDirty();
			this._workItemsMatchQueryDeliverModel.setCurrentForeignQueryOptionID(this._foreignQueryDropDown.value);
		});
		dojo.connect(this._foreignQueryDropDown, 'change', foreignQueryOptionHandler);
	},

	_handleComponentDropDownChange: function() {
		if (this._isDestroyed) 
			return ;
		if (this._componentsDropDown.value != null) {
			if (this._componentsDropDown.value === ProcessSpecificationConstants.VAL_TRUE) {
				this._componentGrid.getGridViewerNode().setReadOnly(true);
				this._addComponentButton.set("enabled",false);
			} else {
				this._componentGrid.getGridViewerNode().setReadOnly(false);
				this._addComponentButton.set("enabled",true);
			}
		}
	},

	_onPreconditionsFetchSuccess: function(nul) {
		if (this._isDestroyed) 
			return null;
		var params= {};
		params.componentsList= this._workItemsMatchQueryDeliverModel.getPreconditionComponents();
		params.modelChangehandler= dojo.hitch(this, 'modelChanged');
		this._workItemsMatchQueryDeliverModel.createComponentsGridViewModel(params);
		this._componentGrid.showGridViewer(this._workItemsMatchQueryDeliverModel.getComponentsGridViewModel());
		this._setQueryName(this._workItemsMatchQueryDeliverModel.getCurrentQuery());
		this._setDropDownOption();
		this._messageDisplayWidget.hideProgressMessage();
		dojo.toggleClass(this._mainContent, ProcessSpecificationConstants.STYLE_HIDE, false);
		return null;
	},

	_onReceivingError: function(error) {
		console.error(error);
		this._messageDisplayWidget.showErrorMessage(error);
		return error;
	},

	_setDropDownOption: function() {
		this._componentsDropDown.value= this._workItemsMatchQueryDeliverModel.getComponentID();
		this._changesetDropDown.value= this._workItemsMatchQueryDeliverModel.getCurrentWorkItemOptionID();
		this._otherProjectAreaDropDown.value= this._workItemsMatchQueryDeliverModel.getCurrentProjectAreaOptionID();
		this._foreignQueryDropDown.value= this._workItemsMatchQueryDeliverModel.getCurrentForeignQueryOptionID();
		this._handleComponentDropDownChange();
		return ;
	},

	_handleAddQuery: function() {
		if (this._isDestroyed) 
			return ;
		var params= {};
		params.allowMultipleSelections= false;
		params.defaultQuery= this._workItemsMatchQueryDeliverModel.getCurrentQuery();
		params.projectAreaID= this.getProcessInformation().getProjectAreaId();
		params.projectAreaName= this.getProcessInformation().getProjectAreaName();
		params.okCallBack= dojo.hitch(this, function(result) {
			this._setQueryName(result);
			this._workItemsMatchQueryDeliverModel.setCurrentQuery(result);
			this._workItemsMatchQueryDeliverModel.markDirty();
		});
		var dialog= new WorkItemQuerySelectionDialog(params);
		dialog.showDialog();
	},

	_handleAddTableEntry: function() {
		if (this._isDestroyed) 
			return ;
		this._componentGrid.addComponents();
	},

	_setQueryName: function(query) {
		if (query != null) {
			dojo.place(dojo.doc.createTextNode(query.name), this._queryDisplayNode, 'only');
		} else if (this._workItemsMatchQueryDeliverModel.getInitialConfiguredQueryId() != null) {
			dojo.place(dojo.doc.createTextNode(dojo.string.substitute(OperationBehaviorMessages.WorkItemsMatchQueryDeliver_messageQueryMissing, [ this._workItemsMatchQueryDeliverModel.getInitialConfiguredQueryId() ]) ), this._queryDisplayNode, 'only');
		}
	},

	$interfaces: {
		'com.ibm.team.scm.web.ui.internal.process.operationbehavior.ComponentsGridViewer.ComponentsGridViewModel.ComponentModelChangeHandler': true
	}
});

})();
